// Generated by CoffeeScript 1.9.3
var Attr, Container, preparePageOptions, that;

Attr = require('./attr');

preparePageOptions = require('./util').preparePageOptions;

that = this;

Container = (function() {
  function Container(_pageUrl, _scraper, _findType) {
    var extractor;
    this._pageUrl = _pageUrl;
    this._scraper = _scraper;
    this._findType = _findType;
    this._index = 0;
    this._attrName = 'href';
    extractor = require('./extractor');
    that.FindType = extractor.FindType;
  }

  Container.prototype.page = function(attrName, options) {
    var targetAttr, targetOptions, url;
    targetAttr = 'href';
    targetOptions = {};
    if (typeof attrName === 'object') {
      targetAttr = 'href';
      targetOptions = attrName;
    } else if (typeof attrName === 'string') {
      targetAttr = attrName;
      targetOptions = options;
    }
    url = this._getAttr(targetAttr);
    targetOptions = preparePageOptions(this._pageUrl, targetOptions);
    return require('./core').page(url, targetOptions);
  };

  Container.prototype._getAttr = function(attrName, index) {
    var _attr;
    if (attrName == null) {
      attrName = this._attrName;
    }
    if (index == null) {
      index = this._index;
    }
    if (this._findType === that.FindType.cheerio) {
      _attr = this._find[index].attribs[attrName];
    } else if (this._findType === that.FindType.xpath) {
      _attr = this._find.attributes.getNamedItem(attrName).value;
    }
    return _attr;
  };

  Container.prototype.attr = function(attrName, index, _attr) {
    if (_attr == null) {
      _attr = this._getAttr(attrName, index);
    }
    return new Attr(this._pageUrl, this._find, this._findType, _attr);
  };

  Container.prototype.all = function(attrName) {
    var i, index, ref, results;
    if (this._findType === that.FindType.cheerio) {
      results = [];
      for (index = i = 0, ref = this._find.length - 1; 0 <= ref ? i <= ref : i >= ref; index = 0 <= ref ? ++i : --i) {
        results.push(this.attr(attrName, index));
      }
      return results;
    } else {
      return [attr(attrName)];
    }
  };

  Container.prototype.href = function() {
    return this.attr('href');
  };

  Container.prototype.text = function() {
    var _attr;
    if (this._findType === that.FindType.cheerio) {
      _attr = this._find.index(this._index).text();
    } else if (this._findType === that.FindType.xpath) {
      _attr = this._find.textContent;
    }
    return attr(null, null, _attr);
  };

  Container.prototype.index = function(index) {
    this._index = index;
    return this;
  };

  Container.prototype.download = function() {
    var attrInstance;
    attrInstance = this.href();
    return attrInstance.download.apply(attrInstance, arguments);
  };

  return Container;

})();

module.exports = Container;
