// Generated by CoffeeScript 1.9.3
var Container, DOMParser, Extractor, FindType, Promise, xpath;

Container = require('./container');

xpath = require('xpath');

DOMParser = require('xmldom').DOMParser;

Promise = require('bluebird');

FindType = {
  jquery: 0,
  qsa: 0,
  cheerio: 0,
  xpath: 1
};

Extractor = (function() {
  function Extractor(_url, _scraper) {
    this._url = _url;
    this._scraper = _scraper;
  }

  Extractor.prototype.find = function(query, callback) {
    var container, thisClass;
    container = new Container(this._url, this._scraper, FindType.cheerio);
    thisClass = this;
    return new Promise(function(resolve, reject) {
      return thisClass._scraper.scrape(function($) {
        return container._find = $(query);
      }, function() {
        if (typeof callback === 'function') {
          callback(container);
        }
        return resolve(container);
      });
    });
  };

  Extractor.prototype.findXpath = function(query, callback) {
    var container, thisClass;
    container = new Container(this._url, this._scraper, FindType.xpath);
    thisClass = this;
    return new Promise(function(resolve, reject) {
      return thisClass._scraper.scrape(function() {
        var doc, nodes;
        doc = new DOMParser().parseFromString(thisClass._scraper.scraper.body, "text/html");
        nodes = xpath.select(query, doc);
        return container._find = nodes;
      }, function() {
        if (typeof callback === 'function') {
          callback(container);
        }
        return resolve(container);
      });
    });
  };

  return Extractor;

})();

exports.Extractor = Extractor;

exports.FindType = FindType;
